﻿//
// 設定ダイアログ
//
#include "configbox.h"

static wxString dbg_list[] = {
	_("0"), _("1"), _("2")
};
static wxString rate_list[] = {
	_("11025"), _("22050"), _("44100"), _("48000")
};
static wxString bits_list[] = {
	_("8"), _("16")
};

// Attach Event
BEGIN_EVENT_TABLE(ConfigBox, wxDialog)
	EVT_CHECKBOX(IDC_CHK_CORRECT, ConfigBox::OnClickCorrect)
	EVT_RADIOBUTTON(IDC_RADIO_7BIT, ConfigBox::OnClick7bit)
	EVT_RADIOBUTTON(IDC_RADIO_8BIT, ConfigBox::OnClick8bit)
	EVT_RADIOBUTTON(IDC_RADIO_STOP1BIT, ConfigBox::OnClickStop1bit)
	EVT_RADIOBUTTON(IDC_RADIO_STOP2BIT, ConfigBox::OnClickStop2bit)
END_EVENT_TABLE()

ConfigBox::ConfigBox(wxWindow* parent, wxWindowID id)
	: wxDialog(parent, id, _("オプション"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE)
{
	wxSizerFlags flags = wxSizerFlags().Expand().Border(wxALL, 4);

	wxBoxSizer *szrLeft   = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *szrRight  = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *szrMain   = new wxBoxSizer(wxHORIZONTAL);
	wxBoxSizer *szrAll    = new wxBoxSizer(wxVERTICAL);
	wxBoxSizer *bszr;
	wxGridSizer *gszr;
	

	wxBoxSizer *szrWav2L3c = new wxStaticBoxSizer(new wxStaticBox(this, wxID_ANY, _("wav -> l3c")), wxVERTICAL);
	gszr = new wxFlexGridSizer(3, 3, 0, 0);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("")), flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("- 1200Hz -")), flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("- 2400Hz -")), flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("中心(Hz)")), flags);
	spinFreq1200 = new wxSpinCtrl(this, IDC_SPIN_FREQ1200);
	gszr->Add(spinFreq1200, flags);
	spinFreq2400 = new wxSpinCtrl(this, IDC_SPIN_FREQ2400);
	gszr->Add(spinFreq2400, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("誤差(%)")), flags);
	spinRange1200 = new wxSpinCtrl(this, IDC_SPIN_RANGE1200);
	gszr->Add(spinRange1200, flags);
	spinRange2400 = new wxSpinCtrl(this, IDC_SPIN_RANGE2400);
	gszr->Add(spinRange2400, flags);
	szrWav2L3c->Add(gszr, flags);
	bszr = new wxBoxSizer(wxHORIZONTAL);
	chkReverse = new wxCheckBox(this, IDC_CHK_REVERSE, _("波形を反転する"));
	chkHalfwave = new wxCheckBox(this, IDC_CHK_HALFWAVE, _("半波検出"));
	bszr->Add(chkReverse, flags);
	bszr->Add(chkHalfwave, flags);
	szrWav2L3c->Add(bszr, flags);
	bszr = new wxBoxSizer(wxHORIZONTAL);
	chkCorrect = new wxCheckBox(this, IDC_CHK_CORRECT, _("補正する"));
	radCorrCosw = new wxRadioButton(this, IDC_RADIO_COSW, _("cos wave"),wxDefaultPosition,wxDefaultSize,wxRB_GROUP);
	radCorrSinw = new wxRadioButton(this, IDC_RADIO_SINW, _("sin wave"));
	bszr->Add(chkCorrect, flags);
	bszr->Add(radCorrCosw, flags);
	bszr->Add(radCorrSinw, flags);
	szrWav2L3c->Add(bszr);
	szrLeft->Add(szrWav2L3c);

	wxBoxSizer *szrL3c2L3b = new wxStaticBoxSizer(new wxStaticBox(this, wxID_ANY, _("l3c <-> l3b")), wxVERTICAL);
	bszr = new wxBoxSizer(wxHORIZONTAL);
    bszr->Add(new wxStaticText(this, wxID_ANY, _("ボーレート")), flags);
	radBaud600 = new wxRadioButton(this, IDC_RADIO_BAUD_600, _("600"),wxDefaultPosition,wxDefaultSize,wxRB_GROUP);
	radBaud1200 = new wxRadioButton(this, IDC_RADIO_BAUD_1200, _("1200"));
	bszr->Add(radBaud600, flags);
	bszr->Add(radBaud1200, flags);
	chkBaudAuto = new wxCheckBox(this, IDC_CHK_BAUDAUTO, _("自動判定"));
	bszr->Add(chkBaudAuto, flags);
	szrL3c2L3b->Add(bszr);
	szrLeft->Add(szrL3c2L3b, flags);
	
	bszr = new wxBoxSizer(wxHORIZONTAL);
	bszr->Add(new wxStaticText(this, wxID_ANY, _("DebugLogLevel")), flags);
	comDebugLevel = new wxComboBox(this, IDC_COMBO_DEBUG, _(""), wxDefaultPosition, wxDefaultSize, 3, dbg_list, wxCB_DROPDOWN | wxCB_READONLY);
	bszr->Add(comDebugLevel, flags);
	szrLeft->Add(bszr, flags);

	/* */
	wxBoxSizer *szrWavFile = new wxStaticBoxSizer(new wxStaticBox(this, wxID_ANY, _("Wav file")), wxVERTICAL);
	gszr = new wxFlexGridSizer(2, 3, 0, 0);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Sample rate")), flags);
	comSRate = new wxComboBox(this, IDC_COMBO_SRATE, _(""), wxDefaultPosition, wxDefaultSize, 4, rate_list, wxCB_DROPDOWN | wxCB_READONLY);
	gszr->Add(comSRate, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Hz")), flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Sample bits")), flags);
	comSBits = new wxComboBox(this, IDC_COMBO_SBITS, _(""), wxDefaultPosition, wxDefaultSize, 2, bits_list, wxCB_DROPDOWN | wxCB_READONLY);
	gszr->Add(comSBits, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("bits")), flags);
	szrWavFile->Add(gszr, flags);
	szrRight->Add(szrWavFile, flags);

	wxBoxSizer *szrL3b2L3 = new wxStaticBoxSizer(new wxStaticBox(this, wxID_ANY, _("l3b <-> l3")), wxVERTICAL);
	gszr = new wxFlexGridSizer(3, 4, 0, 0);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Data")), flags);
	radData7bit = new wxRadioButton(this, IDC_RADIO_7BIT, _("7bit"),wxDefaultPosition,wxDefaultSize,wxRB_GROUP);
	radData8bit = new wxRadioButton(this, IDC_RADIO_8BIT, _("8bit"));
	gszr->Add(radData7bit, flags);
	gszr->Add(radData8bit, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("")), flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Parity")), flags);
	radParityNo = new wxRadioButton(this, IDC_RADIO_PARITY_NO, _("No"),wxDefaultPosition,wxDefaultSize,wxRB_GROUP);
	radParityEven = new wxRadioButton(this, IDC_RADIO_PARITY_EVEN, _("Even"));
	radParityOdd = new wxRadioButton(this, IDC_RADIO_PARITY_ODD, _("Odd"));
	gszr->Add(radParityNo, flags);
	gszr->Add(radParityEven, flags);
	gszr->Add(radParityOdd, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("Stopbit")), flags);
	radStop1bit = new wxRadioButton(this, IDC_RADIO_STOP1BIT, _("1bit"),wxDefaultPosition,wxDefaultSize,wxRB_GROUP);
	radStop2bit = new wxRadioButton(this, IDC_RADIO_STOP2BIT, _("2bit"));
	gszr->Add(radStop1bit, flags);
	gszr->Add(radStop2bit, flags);
	gszr->Add(new wxStaticText(this, wxID_ANY, _("")), flags);
	szrL3b2L3->Add(gszr, flags);
	szrRight->Add(szrL3b2L3, flags);

	wxBoxSizer *szrRealFile = new wxStaticBoxSizer(new wxStaticBox(this, wxID_ANY, _("実ファイル")), wxVERTICAL);
	chkSplit = new wxCheckBox(this, IDC_CHK_SPLIT, _("プログラムごとにファイルを分割する"));
	chkMHead = new wxCheckBox(this, IDC_CHK_MHEAD, _("マシン語のヘッダを取り除く"));

	szrRealFile->Add(chkSplit, flags);
	szrRealFile->Add(chkMHead, flags);
	szrRight->Add(szrRealFile, flags);

	wxSizer *szrButtons = CreateButtonSizer(wxOK|wxCANCEL);
	szrMain->Add(szrLeft, flags);
	szrMain->Add(szrRight, flags);
	szrAll->Add(szrMain, flags);
	szrAll->Add(szrButtons, flags);

	SetSizerAndFit(szrAll);
}

int ConfigBox::ShowModal()
{
	init_dialog();
	int rc = wxDialog::ShowModal();
	if (rc == wxID_OK) {
		term_dialog();
	}
	return rc;
}

void ConfigBox::init_dialog()
{
		spinRange1200->SetRange(1, 100);
		spinRange1200->SetValue(param.range1200);
	
		spinRange2400->SetRange(1, 100);
		spinRange2400->SetValue(param.range2400);

		spinFreq1200->SetRange(600, 1800);
		spinFreq1200->SetValue(param.freq1200);
	
		spinFreq2400->SetRange(1800, 3000);
		spinFreq2400->SetValue(param.freq2400);
	
		chkReverse->SetValue(param.reverse ? true : false);
		chkHalfwave->SetValue(param.half_wave ? true : false);

		radCorrCosw->SetValue(param.correct_type == 0 ? true : false);
		radCorrSinw->SetValue(param.correct_type == 1 ? true : false);
		if (param.correct == 1) {
			chkCorrect->SetValue(true);
			radCorrCosw->Enable(true);
			radCorrSinw->Enable(true);
		} else {
			chkCorrect->SetValue(false);
			radCorrCosw->Enable(false);
			radCorrSinw->Enable(false);
		}

		//
		comSRate->Select(param.sample_rate);
		comSBits->Select(param.sample_bits);

		//
		if (param.baud == 1) {
			radBaud1200->SetValue(true);
			radBaud600->SetValue(false);
		} else {
			radBaud1200->SetValue(false);
			radBaud600->SetValue(true);
		}
		chkBaudAuto->SetValue(param.auto_baud ? true : false);

		//
		if ((param.word_select & 0x04) == 0) {
			// 7bit
			radData7bit->SetValue(true);
			radData8bit->SetValue(false);
			radParityNo->Enable(false);
		} else {
			// 8bit
			radData7bit->SetValue(false);
			radData8bit->SetValue(true);
			radParityNo->Enable(true);
		}
		if ((param.word_select & 0x02) == 0 && param.word_select != 5) {
			radStop1bit->SetValue(false);
			radStop2bit->SetValue(true);
		} else {
			radStop1bit->SetValue(true);
			radStop2bit->SetValue(false);
		}

		radParityEven->Enable(true);
		radParityOdd->Enable(true);
		if (param.word_select == 4 || param.word_select == 5) {
			radParityNo->SetValue(true);
			radParityEven->SetValue(false);
			radParityOdd->SetValue(false);
			if (param.word_select == 4) {
				radParityEven->Enable(false);
				radParityOdd->Enable(false);
			}
		} else if ((param.word_select & 0x01) == 0) {
			radParityNo->SetValue(false);
			radParityEven->SetValue(true);
			radParityOdd->SetValue(false);
		} else {
			radParityNo->SetValue(false);
			radParityEven->SetValue(false);
			radParityOdd->SetValue(true);
		}

		chkSplit->SetValue(param.file_split ? true : false);
		chkMHead->SetValue(param.del_mhead ? true : false);

		comDebugLevel->Select(param.debug_log);
}

void ConfigBox::OnClickCorrect(wxCommandEvent& event)
{
	if (chkCorrect->GetValue()) {
		radCorrCosw->Enable(true);
		radCorrSinw->Enable(true);
	} else {
		radCorrCosw->Enable(false);
		radCorrSinw->Enable(false);
	}
}

void ConfigBox::OnClick7bit(wxCommandEvent& event)
{
	if (radData7bit->GetValue()) {
		if (radParityNo->GetValue()) {
			radParityNo->SetValue(false);
			radParityEven->SetValue(true);
		}
		radParityNo->Enable(false);
		radParityEven->Enable(true);
		radParityOdd->Enable(true);
	}
}

void ConfigBox::OnClick8bit(wxCommandEvent& event)
{
	if (radData8bit->GetValue()) {
		radParityNo->Enable(true);
		if (radStop2bit->GetValue()) {
			radParityNo->SetValue(true);
			radParityEven->SetValue(false);
			radParityOdd->SetValue(false);
			radParityEven->Enable(false);
			radParityOdd->Enable(false);
		} else {
			radParityEven->Enable(true);
			radParityOdd->Enable(true);
		}
	}
}

void ConfigBox::OnClickStop1bit(wxCommandEvent& event)
{
	if (radStop1bit->GetValue()) {
		radParityEven->Enable(true);
		radParityOdd->Enable(true);
		if (radData8bit->GetValue()) {
			radParityNo->Enable(true);
		} else {
			radParityNo->Enable(false);
		}
	}
}

void ConfigBox::OnClickStop2bit(wxCommandEvent& event)
{
	if (radStop2bit->GetValue()) {
		if (radData8bit->GetValue()) {
			radParityNo->SetValue(true);
			radParityEven->SetValue(false);
			radParityOdd->SetValue(false);
			radParityNo->Enable(true);
			radParityEven->Enable(false);
			radParityOdd->Enable(false);
		} else {
			if (radParityNo->GetValue()) {
				radParityNo->SetValue(false);
				radParityEven->SetValue(true);
			}
			radParityNo->Enable(false);
			radParityEven->Enable(true);
			radParityOdd->Enable(true);
		}
	}
}

void ConfigBox::term_dialog()
{
	param.range1200 = spinRange1200->GetValue();
	param.range2400 = spinRange2400->GetValue();
	param.freq1200 = spinFreq1200->GetValue();
	param.freq2400 = spinFreq2400->GetValue();

	param.reverse = chkReverse->GetValue() ? 1 : 0;
	param.half_wave = chkHalfwave->GetValue() ? 1 : 0;
	param.correct = chkCorrect->GetValue() ? 1 : 0;

	if (radCorrCosw->GetValue()) {
		param.correct_type = 0;
	} else {
		param.correct_type = 1;
	}

	param.sample_rate = comSRate->GetCurrentSelection();
	param.sample_bits = comSBits->GetCurrentSelection();

	if (radBaud600->GetValue()) {
		param.baud = 0;
	} else {
		param.baud = 1;
	}
	param.auto_baud = chkBaudAuto->GetValue() ? 1 : 0;

	param.word_select = 0;
	if (radData8bit->GetValue()) {
		param.word_select |= 0x04;
	}
	if (radStop1bit->GetValue()) {
		param.word_select |= 0x02;
	}
	if (radParityOdd->GetValue()) {
		param.word_select |= 0x01;
	}
	if (radData8bit->GetValue()
		&& radParityNo->GetValue()) {
		if (radStop1bit->GetValue()) {
			param.word_select = 5;
		} else {
			param.word_select = 4;
		}
	}

	param.debug_log = comDebugLevel->GetCurrentSelection();

	param.file_split = chkSplit->GetValue() ? 1 : 0;
	param.del_mhead  = chkMHead->GetValue() ? 1 : 0;
}
